"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@reactive-js/react");
const observable_resource_1 = require("@reactive-js/observable-resource");
const react_2 = require("react");
const empty = {
    path: "",
    query: "",
    fragment: "",
};
exports.Router = function Router(props) {
    const { locationStoreFactory, notFound, routes, scheduler } = props;
    const element = react_1.useObservableResource(() => {
        const routeMap = {};
        for (const [path, component] of routes) {
            routeMap[path] = component;
        }
        const locationResource = locationStoreFactory();
        const uriUpdater = (updater) => {
            locationResource.dispatch(updater);
        };
        const pairify = ([_, oldState], next) => oldState === empty ? [undefined, next] : [oldState, next];
        return observable_resource_1.pipe(locationResource, observable_resource_1.scan(pairify, [undefined, empty]), observable_resource_1.map(([referer, uri]) => react_2.createElement(routeMap[uri.path] || notFound, {
            referer,
            uri,
            uriUpdater,
        })));
    }, [locationStoreFactory, notFound, routes], scheduler);
    return (element !== null && element !== void 0 ? element : null);
};
//# sourceMappingURL=router.js.map